"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _lodash = _interopRequireDefault(require("lodash"));

var _ConditionExecutor = _interopRequireDefault(require("./ConditionExecutor"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

var ConditionPaser =
/*#__PURE__*/
function () {
  function ConditionPaser(conditions, data) {
    _classCallCheck(this, ConditionPaser);

    this.conditions = conditions || [];
    this.data = data || [];
  } //执行条件


  _createClass(ConditionPaser, [{
    key: "execCondition",
    value: function execCondition() {
      var _this = this;

      return _lodash["default"].map(this.conditions, function (group) {
        return _lodash["default"].map(group, function (condition) {
          return _objectSpread({}, condition, {
            result: _ConditionExecutor["default"].exec(condition, _this.data)
          });
        });
      });
    } //合并每个条件执行结果, 产生最终结果

  }, {
    key: "mergeResult",
    value: function mergeResult(resultList) {
      var result = false;

      _lodash["default"].forEach(resultList, function (group) {
        //如果没有结果是false的条件
        if (!_lodash["default"].isEmpty(group) && !_lodash["default"].find(group, {
          result: false
        })) {
          result = true;
          return;
        }
      });

      return result;
    } //获取结果

  }, {
    key: "getResult",
    value: function getResult() {
      //每个条件的执行结果
      var resultList = this.execCondition();
      return {
        conditionResult: this.mergeResult(resultList),
        detail: resultList
      };
    }
  }]);

  return ConditionPaser;
}();

var _default = ConditionPaser;
exports["default"] = _default;