"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _mkTranslate = _interopRequireDefault(require("../../../utils/mkTranslate"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var FilterListPanel =
/*#__PURE__*/
function (_Component) {
  _inherits(FilterListPanel, _Component);

  function FilterListPanel(props) {
    var _this;

    _classCallCheck(this, FilterListPanel);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(FilterListPanel).call(this, props));

    _this.localeProcess = function () {
      _mkTranslate["default"].getNameSpace('MkTable').then(function (t) {
        _this.setState({
          t: t
        });
      });
    };

    _this.state = {
      t: _mkTranslate["default"].noop()
    };

    _this.localeProcess();

    return _this;
  }

  _createClass(FilterListPanel, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          list = _this$props.list,
          addItem = _this$props.addItem,
          editItem = _this$props.editItem,
          deleteItem = _this$props.deleteItem,
          emptyImg = _this$props.emptyImg;
      var t = this.state.t;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-filter-setting-list-wrapper")
      }, !!list.length && _react["default"].createElement("div", {
        className: "".concat(prefix, "-filter-setting-list")
      }, list.map(function (item) {
        return _react["default"].createElement("div", {
          className: "".concat(prefix, "-filter-list-item"),
          key: item.code
        }, _react["default"].createElement("div", {
          className: "".concat(prefix, "-filter-list-item-name")
        }, item.filterName), _react["default"].createElement("div", {
          className: "".concat(prefix, "-filter-list-item-actions")
        }, _react["default"].createElement("span", {
          className: "fm fm-modify",
          onClick: function onClick() {
            return editItem(item);
          }
        }), _react["default"].createElement("span", {
          className: "fm fm-trash",
          onClick: function onClick() {
            return deleteItem(item);
          }
        })));
      })), _react["default"].createElement(_button["default"], {
        onClick: addItem,
        className: "add-btn"
      }, _react["default"].createElement("span", {
        className: "fm fm-plus"
      }), t('filterListPanel.add')), !list.length && _react["default"].createElement("div", {
        className: "".concat(prefix, "-filter-empty")
      }, _react["default"].createElement("img", {
        src: emptyImg,
        alt: t('filterListPanel.empty'),
        style: {
          width: '80px'
        }
      }), _react["default"].createElement("p", {
        style: {
          marginTop: '10px',
          color: '#757575'
        }
      }, t('filterListPanel.empty'))));
    }
  }]);

  return FilterListPanel;
}(_react.Component);

FilterListPanel.defaultProps = {
  list: []
};
var _default = FilterListPanel;
exports["default"] = _default;