"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var React = _interopRequireWildcard(require("react"));

var _reactPdf = require("react-pdf");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ViewerNav =
/*#__PURE__*/
function (_React$Component) {
  _inherits(ViewerNav, _React$Component);

  function ViewerNav() {
    var _this;

    _classCallCheck(this, ViewerNav);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ViewerNav).call(this));

    _this.handleChangeImg = function (newIndex) {
      if (_this.props.activeIndex === newIndex) {
        return;
      }

      _this.props.onChangeImg(newIndex);
    };

    _this.state = {};
    return _this;
  } // static defaultProps = {
  //     activeIndex: 0,
  // };


  _createClass(ViewerNav, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var releaseStyle = {
        width: "".concat(this.props.navbarWidth ? "".concat(this.props.navbarWidth, "px") : 'auto')
      };
      var listStyle = {
        transform: "translateX(".concat(this.props.compareDistance, "px)")
      };
      return React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-navbar")
      }, React.createElement("p", null, this.props.activeIndex + 1, " / ", this.props.files.length), React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-navbar-switch")
      }, React.createElement("i", {
        className: "fm fm-angle-left",
        onClick: this.props.onPrev
      }), React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-list-switch"),
        ref: this.props.refNavBar
      }, React.createElement("div", {
        className: "".concat(this.props.prefixCls, "-list-release"),
        style: releaseStyle
      }, React.createElement("ul", {
        className: "".concat(this.props.prefixCls, "-list ").concat(this.props.prefixCls, "-list-transition"),
        style: listStyle
      }, this.props.files.map(function (item, index) {
        return React.createElement("li", {
          key: index,
          className: "".concat(index === _this2.props.activeIndex ? 'active' : null, " ").concat(item.validateStatus === 'VALIDATED' ? 'proven-true' : null),
          onClick: function onClick() {
            _this2.handleChangeImg(index);
          }
        }, item.src ? item.imageType.includes('pdf') ? React.createElement(_reactPdf.Document, {
          file: item.src,
          loading: null,
          options: {
            cMapUrl: 'cmaps/',
            cMapPacked: true,
            fontFamily: 'Microsoft YaHei'
          }
        }, React.createElement(_reactPdf.Page, {
          pageNumber: 1,
          height: 40
        })) : React.createElement("img", {
          src: item.src,
          alt: item.alt
        }) : React.createElement("div", {
          className: "empty"
        }, React.createElement("i", {
          className: "fm fm-receipt1"
        })), item.validateStatus === 'VALIDATED' && React.createElement("i", {
          className: "fm fm-proven-true"
        }));
      })))), React.createElement("i", {
        className: "fm fm-angle-right",
        onClick: this.props.onNext
      })));
    }
  }]);

  return ViewerNav;
}(React.Component);

exports["default"] = ViewerNav;