"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/select/style/css");

var _select = _interopRequireDefault(require("maycur-antd/lib/select"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Option = _select["default"].Option;

var SelectFilter =
/*#__PURE__*/
function (_Component) {
  _inherits(SelectFilter, _Component);

  function SelectFilter(props) {
    var _this;

    _classCallCheck(this, SelectFilter);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(SelectFilter).call(this, props));

    _this.onChange = function (value) {
      _this.setState({
        seletcedValue: value
      });

      var _this$props = _this.props,
          setSelectedKeys = _this$props.setSelectedKeys,
          confirm = _this$props.confirm;
      setSelectedKeys(value);
      confirm();
    };

    _this.componentDidMount = function () {
      var _this$props2 = _this.props,
          columns = _this$props2.columns,
          selectedKeys = _this$props2.selectedKeys,
          filterKey = _this$props2.filterKey,
          dataIndex = _this$props2.dataIndex;

      if (selectedKeys) {
        var column = _lodash["default"].find(columns, {
          dataIndex: dataIndex
        });

        if (column) {
          _this.setState({
            seletcedValue: selectedKeys[filterKey] || selectedKeys[dataIndex]
          });
        }
      }
    };

    _this.state = {
      filters: props.filters,
      searchKey: null
    };
    return _this;
  }

  _createClass(SelectFilter, [{
    key: "componentDidUpdate",
    // onSearch = (value) => {
    //     const { filters } = this.props;
    //     let filtered;
    //     if (value) {
    //         filtered = _.filter(filters, function (o) {
    //             return _.includes(o.text, value);
    //         })
    //     } else {
    //         filtered = filters;
    //     }
    //     this.setState({ filters: filtered })
    // }
    value: function componentDidUpdate(preProps) {
      if (preProps.filters.length !== this.props.filters.length) {
        this.setState({
          filters: this.props.filters
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var _this$props3 = this.props,
          placeholder = _this$props3.placeholder,
          filterMultiple = _this$props3.filterMultiple,
          _this$props3$showSear = _this$props3.showSearch,
          showSearch = _this$props3$showSear === void 0 ? true : _this$props3$showSear;
      var _this$state = this.state,
          filters = _this$state.filters,
          seletcedValue = _this$state.seletcedValue;
      return _react["default"].createElement(_select["default"], {
        mode: filterMultiple ? "multiple" : "",
        placeholder: placeholder,
        showSearch: showSearch,
        value: seletcedValue,
        onChange: this.onChange,
        filterOption: true,
        optionFilterProp: "children"
      }, !!filters && filters.map(function (filter) {
        return _react["default"].createElement(Option, {
          value: filter.value,
          key: filter.value
        }, filter.text);
      }));
    }
  }]);

  return SelectFilter;
}(_react.Component);

var _default = SelectFilter;
exports["default"] = _default;