"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = interpolate;

var _interpolator = _interopRequireDefault(require("./interpolator"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// Compute a number a percentage distance between a and b.
// Usage: interpolate(0, 100, 0.5) == 50
// Credit: https://github.com/sveltejs/svelte/blob/master/src/motion/tweened.ts
function interpolate(a, b, percentage) {
  return (0, _interpolator["default"])(a, b)(percentage);
}