"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/modal/style/css");

var _modal = _interopRequireDefault(require("maycur-antd/lib/modal"));

require("maycur-antd/lib/icon/style/css");

var _icon = _interopRequireDefault(require("maycur-antd/lib/icon"));

var _react = _interopRequireWildcard(require("react"));

var _i18next = require("i18next");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var ConfirmModal =
/*#__PURE__*/
function (_Component) {
  _inherits(ConfirmModal, _Component);

  function ConfirmModal(props) {
    var _this;

    _classCallCheck(this, ConfirmModal);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(ConfirmModal).call(this, props));

    _this.handleOk = function () {
      var _this$props = _this.props,
          promise = _this$props.promise,
          afterSubmit = _this$props.afterSubmit;

      if (afterSubmit) {
        afterSubmit(promise);
      } else if (promise && typeof promise.resolve === 'function') {
        promise.resolve();
      }
    };

    _this.state = {};
    return _this;
  }

  _createClass(ConfirmModal, [{
    key: "render",
    value: function render() {
      var _this$props2 = this.props,
          title = _this$props2.title,
          subTitle = _this$props2.subTitle,
          iconType = _this$props2.iconType,
          content = _this$props2.content,
          size = _this$props2.size,
          okText = _this$props2.okText,
          cancelText = _this$props2.cancelText;
      return _react["default"].createElement(_modal["default"], _extends({
        visible: true,
        title: title,
        onOk: this.handleOk,
        okText: okText,
        cancelText: cancelText,
        cancelButtonProps: {
          type: 'info'
        },
        wrapClassName: "ant-modal-".concat(size)
      }, this.props), subTitle ? _react["default"].createElement("div", {
        className: "title"
      }, _react["default"].createElement(_icon["default"], {
        type: iconType
      }), _react["default"].createElement("div", {
        className: "sub-title"
      }, subTitle)) : null, _react["default"].createElement("div", {
        className: "content"
      }, content));
    }
  }]);

  return ConfirmModal;
}(_react.Component);

ConfirmModal.defaultProps = {
  okText: (0, _i18next.t)('MkGlobal:ok'),
  cancelText: (0, _i18next.t)('MkGlobal:cancel')
};
var _default = ConfirmModal;
exports["default"] = _default;