"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

require("maycur-antd/lib/button/style/css");

var _button = _interopRequireDefault(require("maycur-antd/lib/button"));

var _react = _interopRequireWildcard(require("react"));

var _lodash = _interopRequireDefault(require("lodash"));

var _DepartmentTransfer = _interopRequireDefault(require("../../../DepartmentSelectionModal/DepartmentTransfer"));

var _utils = _interopRequireDefault(require("../../../utils/utils"));

var _i18next = require("i18next");

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var prefix = _utils["default"].prefixCls;

var DepartmentPickerDropdown =
/*#__PURE__*/
function (_Component) {
  _inherits(DepartmentPickerDropdown, _Component);

  function DepartmentPickerDropdown(props) {
    var _this;

    _classCallCheck(this, DepartmentPickerDropdown);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(DepartmentPickerDropdown).call(this, props));

    _this.onChange = function (selectList) {
      var _this$props = _this.props,
          promise = _this$props.promise,
          confirm = _this$props.confirm,
          setSelectedKeys = _this$props.setSelectedKeys,
          selectedKeys = _this$props.selectedKeys,
          columnModify = _this$props.columnModify,
          col = _objectWithoutProperties(_this$props, ["promise", "confirm", "setSelectedKeys", "selectedKeys", "columnModify"]);

      if (promise) {
        _this.selectList = _lodash["default"].cloneDeep(selectList);
      } else {
        // let value = selectList.map(item => item.code);
        var colCopy = _lodash["default"].cloneDeep(col);

        colCopy.key = colCopy.dataIndex;
        var selectedList = selectList.map(function (item) {
          return item.name;
        });

        if (colCopy) {
          columnModify(colCopy, {
            key: 'selectedList',
            value: selectedList
          });
        }

        setSelectedKeys(selectList);
      }
    };

    _this.onOk = function () {
      var _this$props2 = _this.props,
          confirm = _this$props2.confirm,
          promise = _this$props2.promise;

      if (promise) {
        promise.resolve(_this.selectList);
      } else {
        confirm();
      }
    };

    _this.onCancel = function () {
      var _this$props3 = _this.props,
          confirm = _this$props3.confirm,
          promise = _this$props3.promise;

      if (promise) {
        promise.resolve();
      } else {
        confirm();
      }
    };

    _this.state = {};
    return _this;
  }

  _createClass(DepartmentPickerDropdown, [{
    key: "componentDidMount",
    value: function componentDidMount() {
      var _selectedKeys = [];

      _lodash["default"].each(this.props.selectedKeys, function (key) {
        if (typeof key === 'string') {
          _selectedKeys.push({
            code: key
          });
        } else {
          _selectedKeys.push(key);
        }
      });

      this.setState({
        selectedKeys: _selectedKeys
      });
    }
  }, {
    key: "UNSAFE_componentWillReceiveProps",
    value: function UNSAFE_componentWillReceiveProps(nextProps) {
      var _selectedKeys = [];

      if (nextProps.selectedKeys !== this.props.selectedKeys) {
        _lodash["default"].each(nextProps.selectedKeys, function (key) {
          if (typeof key === 'string') {
            _selectedKeys.push({
              code: key
            });
          } else {
            _selectedKeys.push(key);
          }
        });

        this.setState({
          selectedKeys: _selectedKeys
        });
      }
    }
  }, {
    key: "render",
    value: function render() {
      var selectedKeys = this.state.selectedKeys;
      var filterOption = this.props.filterOption;
      var maxSelectLength = filterOption.maxSelectLength;
      return _react["default"].createElement("div", {
        className: "".concat(prefix, "-department-picker-filter-dropdown")
      }, _react["default"].createElement(_DepartmentTransfer["default"], _extends({
        scope: "DEPARTMENT",
        maxSelectLength: maxSelectLength || 1,
        isShowUserGroup: false,
        onChange: this.onChange,
        selectList: selectedKeys
      }, this.props)), _react["default"].createElement("div", {
        className: 'footer'
      }, _react["default"].createElement("div", {
        className: 'help'
      }, (0, _i18next.t)('MkGlobal:helpText'), _react["default"].createElement("a", {
        href: "https://www.yuque.com/ruanruan-eydfh/yb01tu/adugpa",
        rel: "noopener noreferrer",
        target: "_blank"
      }, (0, _i18next.t)('MkGlobal:help'))), _react["default"].createElement("div", {
        className: 'btn'
      }, _react["default"].createElement(_button["default"], {
        key: "back",
        type: "info",
        size: "large",
        onClick: this.onCancel
      }, (0, _i18next.t)('MkGlobal:cancel')), _react["default"].createElement(_button["default"], {
        key: "submit",
        type: "primary",
        size: "large",
        onClick: this.onOk
      }, (0, _i18next.t)('MkGlobal:ok')))));
    }
  }]);

  return DepartmentPickerDropdown;
}(_react.Component);

var _default = DepartmentPickerDropdown;
exports["default"] = _default;